#include "orderlist.h"
#include <stdio.h>
#include <stdlib.h>

OrderListClass::OrderListClass()
{
	Head=NULL;
   Current=NULL;
   numorder=0;
}

void OrderListClass::add(struct orderstruct innode)
{
 porderstruct temp;

 if (Head!=NULL) {
 	temp=new orderstruct;
   temp->prev=Current;
   temp->next=NULL;
   Current->next=temp;
   setstate(temp,innode);
   Current=temp;
   numorder++;
 }
 else {
 	Head=new orderstruct;
   Head->prev=NULL;
   Head->next=NULL;
   Current=Head;
   setstate(Head,innode);
   numorder=1;
 }
}

bool OrderListClass::gotonext(){
Current=Current->next;
return Current!=NULL;
}

bool OrderListClass::gotoprev(){
Current=Current->prev;
return Current!=NULL;
}

void OrderListClass::gotohead(){
Current=Head;
}

int OrderListClass::getnumorder(){
return numorder;
}
struct orderstruct OrderListClass::getcurrent(){
 return getstate(Current);
}

void OrderListClass::setstate(porderstruct chnode,struct orderstruct chstruct){
   int i;

   chnode->onumber=chstruct.onumber;
   chnode->index=chstruct.index;
   chnode->sttime=chstruct.sttime;
   chnode->endtime=chstruct.endtime;
   chnode->require=chstruct.require;
   for (i=0;i<=chstruct.car[0];i++)chnode->car[i]=chstruct.car[i];
   chnode->alloc=chstruct.alloc;
}

struct orderstruct OrderListClass::getstate(porderstruct outnode){
	struct orderstruct tempstruct;
   int i;

   tempstruct.onumber=outnode->onumber;
   tempstruct.index=outnode->index;
   tempstruct.sttime=outnode->sttime;
   tempstruct.endtime=outnode->endtime;
   tempstruct.require=outnode->require;
   for (i=0;i<=outnode->car[0];i++)tempstruct.car[i]=outnode->car[i];
   tempstruct.alloc=outnode->alloc;
   return tempstruct;
}

void OrderListClass::sort(){
porderstruct temp,first;
int i,j,k;
for (j=1;j<numorder;j++){
 gotohead();
 for (k=1;k<j;k++){if (!gotonext())break;}
 first=Current;
 temp=Current;
 for(i=1;i<numorder-j+1;i++){
  if (!gotonext())break;
  if (Current->sttime<temp->sttime)temp=Current;
 }
  swap(first,temp);
 }
}

void OrderListClass::swap(porderstruct a,porderstruct b){
struct orderstruct temp1,temp2;
temp1=getstate(a);
temp2=getstate(b);
setstate(b,temp1);
setstate(a,temp2);
}

void OrderListClass::allocate(){
Current->alloc=true;}

void OrderListClass::rent(){
Current->alloc=false;}

OrderListClass::~OrderListClass(){
porderstruct temp;
gotohead();
temp=Current;
while (Current!=NULL){
 temp=Current;
 Current=Current->next;
 delete temp;
}
}

bool OrderListClass::last(){
 return (Current==NULL);
}
